%%%%% General parameters
rho=1000; % density of water (kg/m3)
cp=4.12; % specific heat capacity of water (kJ/(kg*C))
T_A=10; % Ambient temperature (C)


%%%%% Parameters of pipelines
fr_coeff=1; % friction coefficient of the pipelines
ht_coeff=0.5; % heat transfer coefficient of the pipelines (kW/(m2*C))
T_init_pipe=20; % initial temperature of the pipes (C)
d_pipe=1; % diameter of the pipes (m)
Tinit=T_init_pipe;
% CS1 - name of the pipeline
t_dead_cs1=2; % dead-time of the pipe (s)
l_cs1=20; % length of the pipe (m)

% CS2 - name of the pipeline
t_dead_cs2=2; % dead-time of the pipe (s)
l_cs2=20; % length of the pipe (m)

% CS3 - name of the pipeline
t_dead_cs3=2; % dead-time of the pipe (s)
l_cs3=20; % length of the pipe (m)

% CS4 - name of the pipeline
t_dead_cs4=2; % dead-time of the pipe (s)
l_cs4=20; % length of the pipe (m)

% CS5 - name of the pipeline
t_dead_cs5=2; % dead-time of the pipe (s)
l_cs5=20; % length of the pipe (m)

% CS6 - name of the pipeline
t_dead_cs6=2; % dead-time of the pipe (s)
l_cs6=20; % length of the pipe (m)

% CS7 - name of the pipeline
t_dead_cs7=2; % dead-time of the pipe (s)
l_cs7=20; % length of the pipe (m)

% CS8 - name of the pipeline
t_dead_cs8=2; % dead-time of the pipe (s)
l_cs8=20; % length of the pipe (m)

% CS9 - name of the pipeline
t_dead_cs9=2; % dead-time of the pipe (s)
l_cs9=20; % length of the pipe (m)

% CS10 - name of the pipeline
t_dead_cs10=2; % dead-time of the pipe (s)
l_cs10=20; % length of the pipe (m)

% CS11 - name of the pipeline
t_dead_cs11=2; % dead-time of the pipe (s)
l_cs11=20; % length of the pipe (m)

% CS1X1 - name of the pipeline
t_dead_cs1x1=2; % dead-time of the pipe (s)
l_cs1x1=20; % length of the pipe (m)

% CS2X1 - name of the pipeline
t_dead_cs2x1=2; % dead-time of the pipe (s)
l_cs2x1=20; % length of the pipe (m)

% CS3X1 - name of the pipeline
t_dead_cs3x1=2; % dead-time of the pipe (s)
l_cs3x1=20; % length of the pipe (m)

% CS1X2 - name of the pipeline
t_dead_cs1x2=2; % dead-time of the pipe (s)
l_cs1x2=20; % length of the pipe (m)

% CS2X2 - name of the pipeline
t_dead_cs2x2=2; % dead-time of the pipe (s)
l_cs2x2=20; % length of the pipe (m)

% CS3X2 - name of the pipeline
t_dead_cs3x2=2; % dead-time of the pipe (s)
l_cs3x2=20; % length of the pipe (m)

%%%%% Parameters of heat-exchangers
%% The pressure drop of the HX is modeled the same way as the pressure drop
%% of a valve
C_valve=0.000003;%0.000010; % valve constant
V_op_HX=50; % valve opening (%) 

% HX-1 
V_cold_1=1; % cold side volume (m3)
V_hot_1=0.5; % hot side volume (m3)
U1 = 9800; %Heat transfer coefficient (W/m2/K)
A1 = 0.065; % Area heat-exchanger (m2)
UA_1=U1*A1; % Area*heat transfer coefficient - constant

T_in_c_1=50; % cold side inlet temp to HX1 (C)
V_coldside_HX1=0.5; % Volume flow rate in cold side of HX1

% HX-2
C_valve_HX2=0.00001;%0.000100; % valve constant
V_cold_2=1; % cold side volume (m3)
V_hot_2=0.5; % hot side volume (m3)
U2 = 9800; %Heat transfer coefficient (W/m2/K)
A2 = 0.7; % Area heat-exchanger (m2)
UA_2=U2*A2;; % Area*heat transfer coefficient - constant

T_in_c_2=50; % cold side inlet temp to HX2 (C)
V_coldside_HX2=0.4; % Volume flow rate in cold side of HX2

% HX-3 
V_cold_3=1; % cold side volume (m3)
V_hot_3=0.5; % hot side volume (m3)
U3 = 9800; %Heat transfer coefficient (W/m2/K)
A3 = 0.4; % Area heat-exchanger (m2)
UA_3=U3*A3; % Area*heat transfer coefficient - constant

T_in_c_3=50; % cold side inlet temp to HX3 (C)
V_coldside_HX3=0.5; % Volume flow rate in cold side of HX3


% HX-X1 
C_valve_h_HXX1=0.00002; % hot side valve constant
V_op_h_HXX1=50; % hot side valve opening (%)
C_valve_c_HXX1=0.00002;%0.00002; % cold side valve constant%%%%%%LAGT TIL EN NULL%%%%%%%
V_op_c_HXX1=50; % cold side valve opening (%)
V_cold_HXX1=0.5; % cold side volume (m3)
V_hot_HXX1=1; % hot side volume (m3)
UX1 = 9800; %Heat transfer coefficient (W/m2/K)
AX1 = 15; % Area heat-exchanger (m2)
UA_HXX1=UX1*AX1; % Area*heat transfer coefficient - constant

% HX-X2
C_valve_h_HXX2=0.00002; % hot side valve constant
V_op_h_HXX2=50; % hot side valve opening (%)
C_valve_c_HXX2=0.000002;%00002; % cold side valve constant%%%%%%%%%%%TATT VEKK TO NULL%%%%%%
V_op_c_HXX2=50; % cold side valve opening (%)
V_cold_HXX2=0.5; % cold side volume (m3)
V_hot_HXX2=1; % hot side volume (m3)
UX2 = 9800; %Heat transfer coefficient (W/m2/K)
AX2 = 5; % Area heat-exchanger (m2)
UA_HXX2=UX2*AX2; % Area*heat transfer coefficient - constant

% Producer 1
V_cold_prod1=1; % cold side volume of HX - producer 1 (m3)
C_valve_prod1=0.00001; % valve constant Producer1
V_op_prod1=50; % valve opening Producer1

% Producer 2
V_cold_prod2=1; % cold side volume of HX - producer 2 (m3)
C_valve_prod2=0.00001; % valve constant Producer2
V_op_prod2=50; % valve opening Producer2

%%%%% Parameters of pumps
mju=90; % Efficiency of the pumps (%)

%%%%% Parameters of valve
% Valve
C_valve_valve=0.00005;%0.001; % valve constant 0.0001
% 
V_secondary=1; % volume flow rate in the secondary circle (m3/s)
V_primary_1=0.4; % volume flow rate in the primary1 circle (m3/s)
V_primary_2=0.4; % volume flow rate in the primary2 circle (m3/s)

Tinit_cs1=Tinit; Tinit_cs2=Tinit; Tinit_cs3=Tinit; Tinit_cs4=Tinit; Tinit_cs5=Tinit; Tinit_cs6=Tinit; Tinit_cs7=Tinit; Tinit_cs8=Tinit; Tinit_cs9=Tinit; Tinit_cs10=Tinit; Tinit_cs11=Tinit;
Tinit_cs1x1=Tinit; Tinit_cs2x1=Tinit; Tinit_cs3x1=Tinit;
Tinit_cs1x2=Tinit; Tinit_cs2x2=Tinit; Tinit_cs3x2=Tinit;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% MPC Parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Ts=1000; % sample time (s)
T_start=0; % start of the simulation
T_end=6000; % end of the simulation
t=[T_start:50:Ts];
time=0; % initial time

% Parameters of the controller
p=4; % length of the prediction horizon
c=1; % length of the control horizon
lamda_Q1=0; % weight for Producer 1 in the objective function
lamda_Q2=0.001; % weight for Producer 2 in the objective function
lamda_P2=1e-3; % weight for Pump2 pump duty in the objective function
lamda_Valve=0.0001; % weight for Valve position in the objective function
lamda_deltaValve=100; % weight for changing the valve in the objective function
lamda=[lamda_Q1 lamda_Q2 lamda_P2 lamda_Valve lamda_deltaValve]; % weight parameter vector


dQ1_max=1e6; % Maximum change of invested heat of Producer 1 in one time step (kW)
dQ2_max=1e6; % Maximum change of invested heat of Producer 2 in one time step (kW)
dP2_max=10000; % Maximum change of Pump2 pump duty in one time step (kW)
dValve_max=10; % Maximum change of Valve position in one time step (%)

delta_ME_mean_max=20000; % trigger for swiching IMC/noIMC mode

% Set point signal
sp_HX1=[ones(45,1).*25000;ones((80-45),1).*60000;ones((length(t)-80),1).*30000];
sp_HX2=[ones(45,1).*21000;ones((80-45),1).*55000;ones((length(t)-80),1).*27000];
sp_HX3=[ones(45,1).*28000;ones((80-45),1).*55000;ones((length(t)-80),1).*32000];


sp=[sp_HX1 sp_HX2 sp_HX3];

